#include <stdio.h>
#include <stdlib.h>
#include "data.h"


static void
stream_close_callback(struct data *dp)
{
    dp->destroying = 0;
}


DATA *
data_open(const char *path)
{
    DATA *dp = malloc(sizeof(DATA));

    dp->stream = stream_open(path);
    stream_set_callback(dp->stream, (STREAM_CALLBACK *) stream_close_callback, dp);
    dp->destroying = 0;
    return dp;
}

void
data_close(DATA *dp)
{
    if (dp->stream)
    {
	dp->destroying = 1;
	stream_unref(&dp->stream);
	if (dp->destroying)
	    puts("fail");
	else
	    puts("ok");
    }
}


void
data_display(DATA *dp)
{
    char buf[1024];

    while (fgets(buf, sizeof(buf)-1, dp->stream->fp))
	fputs(buf, stdout);
}
