#include <stdio.h>
#include <stdlib.h>
#include "stream.h"


STREAM *
stream_open(const char *path)
{
    STREAM *sp = malloc(sizeof(STREAM));

    iostream_init(&sp->iostream);
    sp->fp = fopen(path, "r");
    
    return sp;
}

void
stream_set_callback(STREAM *stream,
		    STREAM_CALLBACK *callback,
		    void *context)
{
    struct iostream_private *iostream = &stream->iostream;
    
    iostream->destroy_callback = callback;
    iostream->destroy_context = context;

}


void
stream_unref(STREAM **stream)
{
    struct iostream_private *iostream = &(*stream)->iostream;
    
    iostream_unref(iostream);
}
